=== debian/changelog ===
quaternion (0.0.95.1-1) unstable; urgency=medium

  * New upstream release.
    - remove unneeded patches
  * debian/control: build-depend on qtquickcontrols2-5-dev

 -- Hubert Chathi <uhoreg@debian.org>  Wed, 27 Oct 2021 15:36:24 -0400
