=== debian/changelog ===
quaternion (0.0.96.1-1) unstable; urgency=medium

  * New ustream release.

 -- Hubert Chathi <uhoreg@debian.org>  Wed, 28 Feb 2024 17:35:09 -0500
