=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Hubert Chathi <uhoreg@debian.org>
 Build-Depends: cmake
  , debhelper-compat (=12)
- , libquotient-dev (>= 0.6.11)
+ , libquotient-dev (>= 0.8.1.2)
  , qt5keychain-dev
  , qtbase5-dev
  , qtdeclarative5-dev
