## quaternion 0.0.97~beta1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,10 +3,10 @@
 cmake_policy(SET CMP0092 NEW)
 endif()
 
-set(IDENTIFIER "com.github.quaternion")
+set(IDENTIFIER "io.github.quotient_im.Quaternion")
 set(COPYRIGHT "Copyright © 2015-2024 The Quaternion contributors")
 
-project(quaternion VERSION 0.0.96.1 LANGUAGES CXX)
+project(quaternion VERSION 0.0.96.81 LANGUAGES CXX)
 
 if(UNIX AND NOT APPLE)
     set(LINUX 1)
@@ -61,18 +61,10 @@
     endforeach ()
 endif()
 
-option(BUILD_WITH_QT6 "Build with Qt 6 (instead of Qt 5)" ON)
-
-if (BUILD_WITH_QT6)
-    set(QtMinVersion "6.2")
-    set(CMAKE_OSX_DEPLOYMENT_TARGET "10.15")
-    set(QUOTIENT "QuotientQt6")
-else()
-    set(QtMinVersion "5.15")
-    set(CMAKE_OSX_DEPLOYMENT_TARGET "10.13")
-    set(QUOTIENT "Quotient")
-endif()
-string(REGEX REPLACE "^(.).*" "Qt\\1" Qt ${QtMinVersion}) # makes "Qt5" or "Qt6"
+set(QtMinVersion "6.4")
+set(QUOTIENT "QuotientQt6")
+set(CMAKE_OSX_DEPLOYMENT_TARGET "10.15")
+string(REGEX REPLACE "^(.).*" "Qt\\1" Qt ${QtMinVersion}) # makes "Qt<MajorVersionDigit>"
 
 # Find the libraries
 find_package(${Qt} ${QtMinVersion} REQUIRED
@@ -101,14 +93,13 @@
 set(QUOTIENT_FORCE_NAMESPACED_INCLUDES 1)
 if ((NOT DEFINED USE_INTREE_LIBQMC OR USE_INTREE_LIBQMC)
         AND EXISTS ${PROJECT_SOURCE_DIR}/lib/Quotient/util.h)
-    option(Quotient_ENABLE_E2EE "end-to-end-encryption (E2EE) support (BETA)" ON)
     add_subdirectory(lib)
     if (NOT DEFINED USE_INTREE_LIBQMC)
         set (USE_INTREE_LIBQMC 1)
     endif ()
 endif ()
 if (NOT USE_INTREE_LIBQMC)
-    find_package(${QUOTIENT} 0.8 REQUIRED)
+    find_package(${QUOTIENT} 0.9 REQUIRED)
     if (NOT ${QUOTIENT}_FOUND)
         message(WARNING "libQuotient not found; configuration will most likely fail.")
         message(WARNING "Make sure you have installed libQuotient development files")
@@ -228,7 +219,7 @@
     ${quaternion_SRCS} ${quaternion_QM}
     ${quaternion_WINRC} ${${PROJECT_NAME}_MAC_ICON})
 
-target_compile_features(${PROJECT_NAME} PRIVATE cxx_std_20)
+target_compile_features(${PROJECT_NAME} PRIVATE cxx_std_23)
 
 target_compile_definitions(${PROJECT_NAME} PRIVATE
     GIT_SHA1="${GIT_SHA1}" LIB_GIT_SHA1="${LIB_GIT_SHA1}")
@@ -240,7 +231,7 @@
     ${Qt}::Widgets ${Qt}::Quick ${Qt}::Qml ${Qt}::Gui ${Qt}::Network ${Qt}::QuickControls2 ${Qt}::QuickWidgets)
 
 set_target_properties(${PROJECT_NAME} PROPERTIES
-    CXX_STANDARD 20
+    CXX_STANDARD 23
     CXX_EXTENSIONS OFF
     VISIBILITY_INLINES_HIDDEN ON
     CXX_VISIBILITY_PRESET hidden
