=== debian/changelog ===
quaternion (0.0.97~beta1-0ubuntu1) plucky; urgency=medium

  * New upstream beta release (0.0.97~beta1).
  * Bump minimum build dep versions of Qt6 and libquotient.

 -- Rik Mills <rikmills@kde.org>  Tue, 03 Dec 2024 12:27:20 +0000

quaternion (0.0.96.1-1ubuntu1) plucky; urgency=medium

  * Build with Qt6 for Qt6 based libquotient transition.

 -- Rik Mills <rikmills@kde.org>  Thu, 28 Nov 2024 16:00:52 +0000
