=== debian/control ===
Source: quaternion
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
Uploaders: Hubert Chathi <uhoreg@debian.org>,
Build-Depends: cmake (>= 3.16),
               debhelper-compat (=13),
               libquotient-dev (>= 0.9.1),
               qt6-base-dev (>= 6.4.0),
               qt6-declarative-dev (>= 6.4.0),
               qt6-multimedia-dev (>= 6.4.0),
               qt6-tools-dev (>= 6.4.0),
               qtkeychain-qt6-dev,
Standards-Version: 4.7.0
Homepage: https://github.com/quotient-im/Quaternion
Vcs-Git: https://salsa.debian.org/matrix-team/quaternion.git
Vcs-Browser: https://salsa.debian.org/matrix-team/quaternion.git

Package: quaternion
Architecture: any
Depends: qml6-module-qtqml,
         qml6-module-qtquick,
         qml6-module-qtquick-controls,
         ${misc:Depends},
         ${shlibs:Depends},
Description: desktop IM client for the Matrix protocol
 Quaternion is a Qt-based chat client for the Matrix protocol.  Matrix is an
 open, federated communications protocol.
