## quaternion 0.0.97.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,9 +4,9 @@
 endif()
 
 set(IDENTIFIER "io.github.quotient_im.Quaternion")
-set(COPYRIGHT "Copyright © 2015-2024 The Quaternion contributors")
-
-project(quaternion VERSION 0.0.96.81 LANGUAGES CXX)
+set(COPYRIGHT "Copyright © The Quotient Project contributors")
+
+project(quaternion VERSION 0.0.97.1 LANGUAGES CXX)
 
 if(UNIX AND NOT APPLE)
     set(LINUX 1)
@@ -99,7 +99,7 @@
     endif ()
 endif ()
 if (NOT USE_INTREE_LIBQMC)
-    find_package(${QUOTIENT} 0.9 REQUIRED)
+    find_package(${QUOTIENT} 0.9.2 REQUIRED)
     if (NOT ${QUOTIENT}_FOUND)
         message(WARNING "libQuotient not found; configuration will most likely fail.")
         message(WARNING "Make sure you have installed libQuotient development files")
@@ -142,35 +142,39 @@
 endif ()
 message(STATUS)
 
+# Windows, this is a GUI executable; OSX, make a bundle
+add_executable(${PROJECT_NAME} WIN32 MACOSX_BUNDLE)
+
 # Set up source files
-set(quaternion_SRCS
-    client/quaternionroom.cpp
-    client/htmlfilter.cpp
-    client/thumbnailprovider.cpp
-    client/activitydetector.cpp
-    client/dialog.cpp
-    client/logindialog.cpp
-    client/networkconfigdialog.cpp
-    client/roomdialogs.cpp
-    client/dockmodemenu.cpp
-    client/mainwindow.cpp
-    client/roomlistdock.cpp
-    client/userlistdock.cpp
-    client/accountselector.cpp
-    client/kchatedit.cpp
-    client/chatedit.cpp
-    client/timelinewidget.cpp
-    client/chatroomwidget.cpp
-    client/systemtrayicon.cpp
-    client/profiledialog.cpp
-    client/models/messageeventmodel.cpp
-    client/models/userlistmodel.cpp
-    client/models/roomlistmodel.cpp
-    client/models/abstractroomordering.cpp
-    client/models/orderbytag.cpp
+target_sources(${PROJECT_NAME} PRIVATE
+    client/quaternionroom.cpp client/quaternionroom.h
+    client/htmlfilter.cpp client/htmlfilter.h
+    client/activitydetector.cpp client/activitydetector.h
+    client/dialog.cpp client/dialog.h
+    client/logindialog.cpp client/logindialog.h
+    client/networkconfigdialog.cpp client/networkconfigdialog.h
+    client/roomdialogs.cpp client/roomdialogs.h
+    client/dockmodemenu.cpp client/dockmodemenu.h
+    client/mainwindow.cpp client/mainwindow.h
+    client/roomlistdock.cpp client/roomlistdock.h
+    client/userlistdock.cpp client/userlistdock.h
+    client/accountselector.cpp client/accountselector.h
+    client/kchatedit.cpp client/kchatedit.h
+    client/chatedit.cpp client/chatedit.h
+    client/timelinewidget.cpp client/timelinewidget.h
+    client/chatroomwidget.cpp client/chatroomwidget.h
+    client/systemtrayicon.cpp client/systemtrayicon.h
+    client/profiledialog.cpp client/profiledialog.h
+    client/verificationdialog.h client/verificationdialog.cpp
+    client/models/messageeventmodel.cpp client/models/messageeventmodel.h
+    client/models/userlistmodel.cpp client/models/userlistmodel.h
+    client/models/roomlistmodel.cpp client/models/roomlistmodel.h
+    client/models/abstractroomordering.cpp client/models/abstractroomordering.h
+    client/models/orderbytag.cpp client/models/orderbytag.h
+    client/desktop_integration.h client/logging_categories.h
     client/main.cpp
     client/resources.qrc
-    )
+)
 
 # quaternion_en.ts is updated explicitly by building trbase target,
 # while all other translation files are created and updated externally at
@@ -180,20 +184,21 @@
                       client/ client/qml/ OPTIONS -no-obsolete)
 add_custom_target(trbase DEPENDS ${quaternion_en_TS})
 
-set(quaternion_TS
+QT_ADD_TRANSLATION(quaternion_QM
     client/translations/quaternion_en_GB.ts
     client/translations/quaternion_de.ts
     client/translations/quaternion_pl.ts
     client/translations/quaternion_ru.ts
     client/translations/quaternion_es.ts
-    )
-QT_ADD_TRANSLATION(quaternion_QM ${quaternion_TS})
+)
+target_sources(${PROJECT_NAME} PRIVATE ${quaternion_QM})
 
 if(WIN32)
     set(quaternion_WINRC quaternion_win32.rc)
-    set_property(SOURCE quaternion_win32.rc APPEND PROPERTY
+    set_property(SOURCE ${quaternion_WINRC} APPEND PROPERTY
         OBJECT_DEPENDS ${PROJECT_SOURCE_DIR}/icons/quaternion.ico
     )
+    target_sources(${PROJECT_NAME} PRIVATE ${quaternion_WINRC})
 endif()
 
 if(APPLE)
@@ -212,12 +217,8 @@
     set(MACOSX_BUNDLE_ICON_FILE ${ICON_NAME})
     set_property(SOURCE "${${PROJECT_NAME}_MAC_ICON}" PROPERTY
         MACOSX_PACKAGE_LOCATION Resources)
+    target_sources(${PROJECT_NAME} PRIVATE ${${PROJECT_NAME}_MAC_ICON})
 endif(APPLE)
-
-# Windows, this is a GUI executable; OSX, make a bundle
-add_executable(${PROJECT_NAME} WIN32 MACOSX_BUNDLE
-    ${quaternion_SRCS} ${quaternion_QM}
-    ${quaternion_WINRC} ${${PROJECT_NAME}_MAC_ICON})
 
 target_compile_features(${PROJECT_NAME} PRIVATE cxx_std_23)
 
@@ -304,9 +305,3 @@
                         "${_qt_translations_dir}/qtdeclarative_*.qm"
                         "${_qt_translations_dir}/qtmultimedia_*.qm"
                         ${PROJECT_NAME}.app/Contents/Translations
-        COMMAND "${${Qt}_BinDir}/macdeployqt" ${MACDEPLOYQT_ARGS}
-        DEPENDS ${PROJECT_NAME}
-        WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
-        COMMENT "Running ${MACDEPLOYQT} with args: ${MACDEPLOYQT_ARGS}"
-    )
-endif(APPLE)
