=== debian/changelog ===
quaternion (0.0.97.1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Aurélien COUDERC <coucouf@debian.org>  Tue, 12 Aug 2025 15:47:11 +0200

quaternion (0.0.97.1-0.1) experimental; urgency=medium

  * Non-maintainer upload.
  * New upstream release (0.0.97.1).
  * Update build-deps and deps with the info from cmake.

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 07 Apr 2025 21:13:33 +0200

quaternion (0.0.96.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build against Qt6. (Closes: #1089828)

 -- Aurélien COUDERC <coucouf@debian.org>  Sat, 21 Dec 2024 10:14:27 +0100
