=== debian/control ===
Source: quaternion
Section: net
Priority: optional
Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
Uploaders: Hubert Chathi <uhoreg@debian.org>,
Build-Depends: debhelper-compat (= 12),
               cmake (>= 3.16~),
               libquotient-dev (>= 0.9.2~),
               qt6-base-dev (>= 6.2~),
               qt6-declarative-dev (>= 6.2~),
               qt6-multimedia-dev (>= 6.2~),
               qt6-tools-dev (>= 6.2~),
               qtkeychain-qt6-dev,
Standards-Version: 4.5.0
Homepage: https://github.com/quotient-im/Quaternion
Vcs-Git: https://salsa.debian.org/matrix-team/quaternion.git
Vcs-Browser: https://salsa.debian.org/matrix-team/quaternion.git

Package: quaternion
Architecture: any
Depends: qml-module-qtquick-controls,
         qml-module-qtquick-controls2,
         ${misc:Depends},
         ${shlibs:Depends},
Description: desktop IM client for the Matrix protocol
 Quaternion is a Qt-based chat client for the Matrix protocol.  Matrix is an
 open, federated communications protocol.
